/*
*  ALCATEL SpeedTouch USB modem utility : CRC lib
*  Copyright (C) 2001 Edouard Gomez
* 
*  This program is free software; you can redistribute it and/or
*  modify it under the terms of the GNU General Public License
*  as published by the Free Software Foundation; either version 2
*  of the License, or (at your option) any later version.
*  
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*  Author : Edouard Gomez (ed.gomez@free.fr)
*  Creation : 08/08/2001
*  Refactor : Matthew Gream (matthew.gream@pobox.com)
*
* $Id: crc.h,v 1.4 2003/11/23 22:26:15 matt Exp $
*/

#ifndef _CRC_H_
#define _CRC_H_


/******************************************************************************
* Constants
******************************************************************************/

#define AAL5_CRC32_REMAINDER 		0xCBF43926
#define AAL5_CRC32_INITIAL 			0xffffffff

#define ATM_HEADER_REMAINDER 		0x107
#define ATM_HEADER_COSET_LEADER 	0x055

#define AAL5_CRC_INIT(f) 			f = AAL5_CRC32_INITIAL
#define AAL5_CRC_CALC(f,d,l)		f = aal5_calc_crc (d,l,f)
#define AAL5_CRC_FINI(f) 			f ^= AAL5_CRC32_INITIAL


/******************************************************************************
* Prototypes
******************************************************************************/

extern unsigned int aal5_calc_crc (const unsigned char *data, 
		const unsigned int length, const unsigned int initial);

extern unsigned char atm_calc_hec (const unsigned char *head);


#endif
